library flutter_chart_plus;

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:path_drawing/path_drawing.dart';
import 'dart:math' as math;
import 'dart:ui' as ui;
import 'src/utils/monotonex.dart';
import 'src/utils/transform_utils.dart';
import 'src/utils/chart_utils.dart';

export 'src/utils/chart_utils.dart';

part 'src/base/chart_controller.dart';
part 'src/state/chart_layout_state.dart';
part 'src/state/chart_state.dart';

part 'src/base/chart_render.dart';
part 'src/base/chart_body_render.dart';

part 'src/coordinate/chart_coordinate_render.dart';
part 'src/coordinate/chart_circular_coordinate_render.dart';
part 'src/coordinate/chart_dimensions_coordinate_render.dart';
part 'src/coordinate/axis.dart';

part 'src/chart/dimensions/bar.dart';
part 'src/chart/dimensions/line.dart';
part 'src/chart/dimensions/scatter.dart';
part 'src/chart/circular/pie.dart';
part 'src/chart/circular/radar.dart';
part 'src/chart/circular/progress.dart';
part 'src/chart/circular/wave_progress.dart';
part 'src/widget/chart_widget.dart';

part 'src/annotation/annotation.dart';
part 'src/annotation/image_annotation.dart';
part 'src/annotation/label_annotation.dart';
part 'src/annotation/limit_annotation.dart';
part 'src/annotation/path_annotation.dart';
part 'src/annotation/region_annotation.dart';

//内部使用
part 'src/state/chart_circular_state.dart';
part 'src/state/chart_dimension_state.dart';
part 'src/state/chart_coordinate_state.dart';
